=== debian/changelog ===
syncthingtray (1.7.3-1) unstable; urgency=medium

  * New upstream release (Closes: #1100350).
  * Update Build-Depends.
  * Migrate to Qt6 and Plasma 6.
  * Drop installation of kservices files, which are not generated for the Qt6
    and Plasma 6 build of Syncthing Tray.
  * Update standards version to 4.7.2 (no changes required).
  * Drop debian/source/options.
  * Build-depend on doxygen.
  * Do a cmake RELEASE build type from now on.
  * Upload to unstable.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 14 Mar 2025 18:57:32 -0600
